#pragma once
#include <stdint.h>
#include <stdbool.h>

#define ASMCALL __attribute__((cdecl))
//void _cdecl x86_div64_32(uint64_t dividend, uint32_t divisor, uint64_t* quotientOut, uint32_t* remainderOut);
//void _cdecl x86_Video_WriteCharTeletype(char c, uint8_t page);
//bool _cdecl x86_Disk_Reset(uint8_t drive);
//bool _cdecl x86_Disk_Read(uint8_t drive,uint16_t cylinder,uint16_t sector,uint16_t head,uint8_t count,void far * dataOut);
//bool _cdecl x86_Disk_GetDriveParams(uint8_t drive,uint8_t* driveTypeOut,uint16_t* cylindersOut,uint16_t* sectorsOut,uint16_t* headsOut);

void ASMCALL x86_outb(uint16_t port, uint8_t value);
uint8_t ASMCALL x86_inb(uint16_t port);

bool ASMCALL x86_Disk_GetDriveParams(uint8_t drive,uint8_t* driveTypeOut,uint16_t* cylindersOut,uint16_t* sectorsOut,uint16_t* headsOut);

bool ASMCALL x86_Disk_Reset(uint8_t drive);

bool ASMCALL x86_Disk_Read(uint8_t drive,uint16_t cylinder,uint16_t sector,uint16_t head,uint8_t count,void* lowerDataOut);

typedef struct {
	uint64_t Base;
	uint64_t Length;
	uint32_t Type;
	uint32_t ACPI;
	
} E820MemoryBlock;

enum E820MemoryBlockType{
	E820_USABLE=1,
	E820_RESERVED=2,
	E820_ACPI_RECLAIMABLE=3,
	E820_ACPI_NVS=4,
	E820_BAD_MEMORY=5,
};

int ASMCALL x86_E820GetNextBlock(E820MemoryBlock* block,uint32_t* continuation_id); //First param will be filled by BIOS